Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 105120)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 105121)
@@ -1160,33 +1160,4 @@
 }
 
-#ifdef RT_OS_LINUX
-/* static */
-void UICommon::checkForWrongUSBMounted()
-{
-    /* Make sure '/proc/mounts' exists and can be opened: */
-    QFile file("/proc/mounts");
-    if (!file.exists() || !file.open(QIODevice::ReadOnly | QIODevice::Text))
-        return;
-
-    /* Fetch contents: */
-    QStringList contents;
-    for (;;)
-    {
-        QByteArray line = file.readLine();
-        if (line.isEmpty())
-            break;
-        contents << line;
-    }
-    /* Grep contents for usbfs presence: */
-    QStringList grep1(contents.filter("/sys/bus/usb/drivers"));
-    QStringList grep2(grep1.filter("usbfs"));
-    if (grep2.isEmpty())
-        return;
-
-    /* Show corresponding warning: */
-    msgCenter().warnAboutWrongUSBMounted();
-}
-#endif /* RT_OS_LINUX */
-
 /* static */
 QString UICommon::usbDetails(const CUSBDevice &comDevice)
@@ -1546,12 +1517,4 @@
 }
 
-void UICommon::sltGUILanguageChange(QString strLanguage)
-{
-    /* Make sure medium-enumeration is not in progress! */
-    AssertReturnVoid(!gpMediumEnumerator->isMediumEnumerationInProgress());
-    /* Load passed language: */
-    UITranslator::loadLanguage(strLanguage);
-}
-
 void UICommon::sltHandleCloudMachineAdded(const QString &strProviderShortName,
                                           const QString &strProfileName,
@@ -1605,4 +1568,12 @@
     /* Call to base-class: */
     return QObject::eventFilter(pObject, pEvent);
+}
+
+void UICommon::sltGUILanguageChange(QString strLanguage)
+{
+    /* Make sure medium-enumeration is not in progress! */
+    AssertReturnVoid(!gpMediumEnumerator->isMediumEnumerationInProgress());
+    /* Load passed language: */
+    UITranslator::loadLanguage(strLanguage);
 }
 
@@ -1806,3 +1777,32 @@
 }
 
+#ifdef RT_OS_LINUX
+/* static */
+void UICommon::checkForWrongUSBMounted()
+{
+    /* Make sure '/proc/mounts' exists and can be opened: */
+    QFile file("/proc/mounts");
+    if (!file.exists() || !file.open(QIODevice::ReadOnly | QIODevice::Text))
+        return;
+
+    /* Fetch contents: */
+    QStringList contents;
+    for (;;)
+    {
+        QByteArray line = file.readLine();
+        if (line.isEmpty())
+            break;
+        contents << line;
+    }
+    /* Grep contents for usbfs presence: */
+    QStringList grep1(contents.filter("/sys/bus/usb/drivers"));
+    QStringList grep2(grep1.filter("usbfs"));
+    if (grep2.isEmpty())
+        return;
+
+    /* Show corresponding warning: */
+    msgCenter().warnAboutWrongUSBMounted();
+}
+#endif /* RT_OS_LINUX */
+
 #endif /* VBOX_WITH_DEBUGGER_GUI */
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 105120)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 105121)
@@ -59,5 +59,5 @@
 signals:
 
-    /** @name Common stuff.
+    /** @name General stuff.
      * @{ */
         /** Asks #UIStarter listener to restart UI. */
@@ -72,5 +72,5 @@
     /** @} */
 
-    /** @name Theme stuff.
+    /** @name Host OS stuff.
      * @{ */
         /** Notifies listeners about theme change. */
@@ -230,5 +230,8 @@
         /** Returns whether VM should start paused. */
         bool shouldStartPaused() const;
-
+    /** @} */
+
+    /** @name Application stuff.
+     * @{ */
 #ifdef VBOX_GUI_WITH_PIDFILE
         /** Creates PID file. */
@@ -239,5 +242,5 @@
     /** @} */
 
-    /** @name COM: Cloud Virtual Machine stuff.
+    /** @name Cloud Virtual Machine stuff.
      * @{ */
         /** Notifies listeners about cloud VM was unregistered.
@@ -259,9 +262,4 @@
     /** @name COM: USB stuff.
      * @{ */
-#ifdef RT_OS_LINUX
-        /** Verifies that USB drivers are properly configured on Linux. */
-        static void checkForWrongUSBMounted();
-#endif
-
         /** Generates details for passed USB @a comDevice. */
         static QString usbDetails(const CUSBDevice &comDevice);
@@ -323,11 +321,5 @@
     /** @} */
 
-    /** @name Localization stuff.
-     * @{ */
-        /** Handles language change to new @a strLanguage. */
-        void sltGUILanguageChange(QString strLanguage);
-    /** @} */
-
-    /** @name Cloud Machine related stuff.
+    /** @name Cloud Virtual Machine stuff.
      * @{ */
         /** Handles signal about cloud machine was added. */
@@ -364,6 +356,12 @@
     /** @} */
 
-    /* Handle font scale factor change. */
-    void sltHandleFontScaleFactorChanged(int iFontScaleFactor);
+    /** @name Localization stuff.
+     * @{ */
+        /** Handles language change to new @a strLanguage. */
+        void sltGUILanguageChange(QString strLanguage);
+
+        /** Handles font @a iFontScaleFactor change. */
+        void sltHandleFontScaleFactorChanged(int iFontScaleFactor);
+    /** @} */
 
 private:
@@ -399,4 +397,12 @@
     /** @} */
 
+    /** @name USB stuff.
+     * @{ */
+#ifdef RT_OS_LINUX
+        /** Verifies that USB drivers are properly configured on Linux. */
+        static void checkForWrongUSBMounted();
+#endif
+    /** @} */
+
     /** Holds the singleton UICommon instance. */
     static UICommon *s_pInstance;
@@ -495,8 +501,11 @@
         /** Holds the --settingspwfile option value. */
         bool  m_fSettingsPwSet;
-
+    /** @} */
+
+    /** @name Application stuff.
+     * @{ */
 #ifdef VBOX_GUI_WITH_PIDFILE
         /** Holds the --pidfile option value (application PID file path). */
-        QString m_strPidFile;
+        QString  m_strPidFile;
 #endif
     /** @} */