Index: trunk/doc/manual/en_US/dita/topics/arm-host-limitations.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/arm-host-limitations.dita	(revision 105166)
+++ trunk/doc/manual/en_US/dita/topics/arm-host-limitations.dita	(revision 105166)
@@ -0,0 +1,31 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
+<topic xml:lang="en-us" id="arm-host-limitations">
+  <title>Arm Platform Host Limitations</title>
+  <!-- 7.1: Arm platform limitations -->
+  <body>
+    <p> The following limitations apply when using an Arm platform host:</p>
+    <ul><li><p>Virtual machines must use an Arm-based guest operating system. Running an x86-based guest operating 
+      system on an Arm host platform is not supported. </p></li>
+    <li><p>Sound emulation is not available.</p></li>
+    <li><p>Only virtio-scsi is supported as a storage controller.</p></li>
+    <li><p>Only VMSVGA is supported as a graphics controller.</p></li>
+      <li><p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> Guest Additions are not available for Arm
+          host platforms. Therefore, features such as seamless windows and shared folders are not
+          available.</p></li>   
+      <li><p>Unattended installation is not available.</p></li>
+      <li><p>The following <b>System</b> page settings may not be available for Arm guests:</p>
+      <ul><li><p><b>Motherboard tab:</b> Chipset, TPM</p></li>
+      <li><p><b>Processor tab:</b> Extended Features such as Enable PAE/NX, Enable Nested VT-x/AMD-V</p></li></ul></li>
+      <li>
+        <p>The following <b>System</b> page settings may not be available for x86 guests:</p>
+        <ul id="ul_zy2_r1b_t1c">
+          <li>
+            <p><b>Acceleration tab:</b> Nested Paging</p>
+          </li>
+        </ul>
+      </li>
+    </ul>
+  </body>
+  
+</topic>
Index: trunk/doc/manual/en_US/dita/topics/cloud-vm-clone.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/cloud-vm-clone.dita	(revision 105166)
+++ trunk/doc/manual/en_US/dita/topics/cloud-vm-clone.dita	(revision 105166)
@@ -0,0 +1,50 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
+<topic xml:lang="en-us" id="cloud-vm-clone">
+  <title>Cloning a Cloud VM</title>
+  
+  <body>
+    <p>
+      When you clone a cloud VM, a copy of the <ph conkeyref="vbox-conkeyref-phrases/oci"/> instance 
+      for the cloud VM is created and associated with the new cloud VM.
+        </p>
+    <p>
+          Perform the following steps to clone a cloud VM:
+        </p>
+    <ol>
+      <li>
+        <p>
+              Click on a cloud profile in the
+              <b outputclass="bold">OCI</b> group.
+            </p>
+        <p>
+              The cloud VMs for the selected cloud profile are
+              displayed.
+            </p>
+      </li>
+      <li>
+        <p>
+              Right-click on the cloud VM you want to clone and select <b outputclass="bold">Clone</b>.
+            </p>
+        <p>
+              The <b outputclass="bold">Clone Name</b> dialog is displayed.
+            </p>
+        <p>Enter a name for the clone.</p>
+        <p>The name you enter is also used as the display name for the related 
+          <ph conkeyref="vbox-conkeyref-phrases/oci"/> instance. The default name for the clone
+          consists of the <codeph>_clone</codeph> suffix appended to the original name. For example,
+            <codeph>ol9-dev_clone</codeph>.</p>
+      </li>
+      <li>
+        <p> Click <b>OK</b> to create the clone and the related <ph
+            conkeyref="vbox-conkeyref-phrases/oci"/> instance. The new instance is started
+          automatically. </p>   
+        <p>
+          The new cloud VM is shown in the
+          <b outputclass="bold">OCI</b> group in <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/>.
+        </p>
+      </li>
+    </ol>
+  </body>
+  
+</topic>
Index: trunk/doc/manual/en_US/dita/topics/cloud-vm-monitor.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/cloud-vm-monitor.dita	(revision 105166)
+++ trunk/doc/manual/en_US/dita/topics/cloud-vm-monitor.dita	(revision 105166)
@@ -0,0 +1,34 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
+<topic xml:lang="en-us" id="cloud-vm-monitor">
+  <title>Monitoring Cloud VM Performance</title>
+  <!--7.1: OCI instance monitoring -->
+  <body>
+    <p>You can monitor the performance of cloud VM instances in the following ways:</p>
+    
+    <ul><li><p>Use the virtual machine monitoring tools in <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/>.</p>
+        <ul><li><p>To show detailed performance data for a cloud VM:</p>
+        <p>Click the cloud VM name in the machine list and select <b>Activity</b> in the machine
+              tools menu.</p>
+            <p>Several time series charts are displayed, showing resource usage and performance
+              data. To save the data to file, click <b>Export</b>.</p></li>
+        <li><p>To show a performance summary for all cloud VMs:</p>
+        <p>Click <b>Activity Overview</b>. The Activity Overview tool is displayed, showing a
+              summary of performance metrics for all running cloud VMs and for the host system.</p></li>
+       </ul>
+      <p>See also <xref href="vm-info.dita"/>.</p>
+    </li>
+      <li>
+        <p> Use the <cmdname>VBoxManage cloud instance</cmdname> command, as follows:</p>
+        <ul><li><p><cmdname>VBoxManage cloud instance metriclist</cmdname> shows the available metrics for an
+              instance.</p></li>
+        <li><p><cmdname>VBoxManage cloud instance metricdata</cmdname> shows metrics data for an instance.</p></li></ul>
+        <p>See also <xref href="vboxmanage-cloud.dita"/>.</p>
+      </li></ul>
+    <note><p>To monitor a cloud VM, the Compute Instance Monitoring plugin must be enabled and running on the
+      <ph conkeyref="vbox-conkeyref-phrases/oci"/> instance. See the <ph conkeyref="vbox-conkeyref-phrases/oci"/> 
+      documentation for more details.</p></note>
+   
+  </body>
+  
+</topic>
Index: trunk/doc/manual/en_US/dita/topics/settings-window.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/settings-window.dita	(revision 105166)
+++ trunk/doc/manual/en_US/dita/topics/settings-window.dita	(revision 105166)
@@ -0,0 +1,31 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
+<topic xml:lang="en-us" id="settings-window">
+  <title>The Settings Window</title>
+  
+  <body>
+    <p>Settings for a virtual machine are configured using the <b>Settings</b> window.</p>
+    <p>To display the <b>Settings</b> window, do either of the following:</p>
+    <ul>
+      <li>
+        <p>In the machine list, right-click the virtual machine name. Select the <b>Settings</b> 
+           menu option.</p>
+      </li>
+      <li>
+        <p>In the machine list, click the virtual machine name. Select the <b>Machine</b>, <b>Settings</b> 
+          menu option.</p>
+      </li>
+      <li>
+        <p>
+          Click the <b>Settings</b> button in the toolbar in the Details pane. See <xref href="gui-details.dita#gui-details"/>.
+        </p>
+      </li>
+    </ul>
+    
+    <note>
+      <p>The available settings depend on the selected experience level. To display all
+       available settings, ensure the experience level is set to <b>Expert</b>.</p>
+      <p>See <xref href="ui-experience-level.dita#gui-experience-level"/>.</p>
+    </note>
+  </body>
+</topic>
Index: trunk/doc/manual/en_US/dita/topics/ui-experience-level.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/ui-experience-level.dita	(revision 105166)
+++ trunk/doc/manual/en_US/dita/topics/ui-experience-level.dita	(revision 105166)
@@ -0,0 +1,52 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
+<topic xml:lang="en-us" id="gui-experience-level">
+  <title>Experience Levels for VirtualBox Manager</title>
+  <body>
+    <p> When you use <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> to configure settings for virtual
+      machines, you can select an <i>experience level</i> for the user interface. The following
+      experience levels are available:</p> 
+    <ul>
+      <li>
+        <p><b>Basic.</b> Only a limited number of settings and tools are shown. This is the
+          default setting.</p>
+        <p>This level is suitable for a first time user of <ph conkeyref="vbox-conkeyref-phrases/product-name"/>.</p>
+      </li>
+      <li>
+        <p><b>Expert.</b> All available settings and tools are shown.</p>
+        <p>This level is suitable for an experienced user who needs more control of virtual machine settings.</p>
+      </li>
+    </ul>
+    <p>Experience levels can be configured in the following places in <ph
+        conkeyref="vbox-conkeyref-phrases/vbox-mgr"/>:</p>
+    <ul>
+      <li><p>The <b>Welcome</b> screen.</p>
+        <note><p>The option disappears from the Welcome screen, after you have selected it.</p></note>
+      </li>
+      <li><p>The <b>Preferences</b> window.</p>
+      </li>
+      <li><p>The <b>Settings</b> window for a virtual machine.</p>
+   </li>
+    </ul>
+    
+    <section id="gui-experience-level-select">
+      <title>Selecting the Experience Level</title>
+      <ol>
+        <li><p>Display the required settings window.</p></li>
+      <li><p>Click <b>Basic</b> or <b>Expert</b> to select the required experience level.</p>
+        <p>
+          <xref href="images/experience-levels.png" format="png" platform="htmlhelp"> 
+            <image href="images/experience-levels.png" placement="break" align="center">
+              <alt>Icon for setting the experience level. Click to enable Basic or Expert mode.</alt>
+            </image>
+          </xref>
+          <image platform="ohc" href="images/experience-levels.png" placement="break" align="center">
+            <alt>Icon for setting the experience level. Click to enable Basic or Expert mode.</alt>
+          </image>
+        </p>
+      <p>The number of available settings and tools might change, depending on the selected
+            experience level.</p></li>
+      </ol>
+    </section>
+  </body>
+</topic>
Index: trunk/doc/manual/en_US/dita/topics/vm-status-bar.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vm-status-bar.dita	(revision 105166)
+++ trunk/doc/manual/en_US/dita/topics/vm-status-bar.dita	(revision 105166)
@@ -0,0 +1,331 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
+<topic xml:lang="en-us" id="vm-status-bar">
+  <title>Virtual Machine Status Bar</title>
+ <!-- 7.1: Processor icon updated --> 
+  <body>
+    <p>
+       A status bar is displayed at the bottom of the virtual machine window. The status bar contains icons 
+       that enable you to view and change settings for the virtual machine, as follows:
+      </p>
+    <ul>
+      <li><p>Highlight an icon to show details of the current settings.</p></li>
+      <li><p>Right-click an icon to change a setting.</p>
+        <p>Some settings, such as audio, can be changed directly by right-clicking the status bar icon. For other
+          settings, you select from the displayed menu options.</p>
+      </li>
+    </ul>
+   
+   <p>See <xref href="BasicConcepts.dita#BasicConcepts"/> for detailed information about the available virtual 
+      machine settings.</p>
+    
+    <p><xref href="#vm-status-bar/table-status-bar-icons"/> describes the icons on the status bar.</p>
+   
+    <table id="table-status-bar-icons">
+      <title>Virtual Machine Status Bar Icons</title>
+      <desc>Describes icons on the status bar located at the bottom of the virtual machine window</desc>
+      <tgroup cols="2">
+        <thead>
+          <row>
+            <entry>
+              <p>
+                <b>Icon</b>
+              </p>
+            </entry>
+            <entry>
+              <p>
+                <b>Description</b>
+              </p>
+            </entry>
+          </row>
+        </thead>
+        <tbody>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_sata.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_sata.png" placement="break" align="center">
+                    <alt>SATA device settings icon on the virtual machine status bar</alt>
+                  </image>
+                </xref>
+                <image platform="ohc" href="images/icon_sata.png" placement="break" align="center">
+                  <alt>SATA device settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Storage (SATA)</b></p>
+              <p>Settings for attached SATA storage devices, such as hard disk drives.</p>
+              <p>See also <xref href="settings-storage.dita#settings-storage"/>.</p>
+              
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_ide.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_ide.png" placement="break" align="center">
+                  <alt>IDE device settings icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_ide.png" placement="break" align="center">
+                  <alt>IDE device settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Storage (IDE)</b></p>
+              <p>Settings for attached IDE storage devices, such as optical CD-ROM drives.</p>
+              <p>See also <xref href="settings-storage.dita#settings-storage"/>.</p>
+              <p>Right-click to show options for adding and removing IDE devices.</p>
+              <p>See also <xref href="intro-removable-media-changing.dita#intro-removable-media-changing"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_audio.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_audio.png" placement="break" align="center">
+                  <alt>Audio settings icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_audio.png" placement="break" align="center">
+                  <alt>Audio settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Audio</b></p>
+              <p>Settings for audio output and audio input.</p>
+              <p>Right-click to change a setting. The status bar icon is updated automatically to show 
+                which settings are enabled.</p>
+              <p>See also <xref href="settings-audio.dita#settings-audio"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_network.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_network.png" placement="break" align="center">
+                  <alt>Network settings icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_network.png" placement="break" align="center">
+                  <alt>Network settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Network</b></p>
+              <p>Settings for attached network adapters.</p>
+              <p>Right-click to connect or disconnect a network adapter.</p>
+              <p>See also <xref href="settings-network.dita#settings-network"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_usb.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_usb.png" placement="break" align="center">
+                  <alt>USB settings icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_usb.png" placement="break" align="center">
+                  <alt>USB settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>USB</b></p>
+              <p>Settings for attached USB devices.</p>
+              <p>Right-click to select from the available USB devices on the host and 
+                to specify a USB filter.</p>
+              <p>See also <xref href="settings-usb.dita#settings-usb"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_shared_folder.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_shared_folder.png" placement="break" align="center">
+                  <alt>Shared folders settings icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_shared_folder.png" placement="break" align="center">
+                  <alt>Shared folders settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Shared Folders</b></p>
+              <p>Settings for shared folders.</p>
+              <p>Right-click to change shared folder settings or to add a new 
+                shared folder.</p>
+              <p>See also <xref href="shared-folders.dita#shared-folders"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_display.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_display.png" placement="break" align="center">
+                  <alt>Display settings icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_display.png" placement="break" align="center">
+                  <alt>Display settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Display</b></p>
+              <p>Settings for the virtual machine display.</p>
+              <p>Right-click to show options for resizing and scaling the display.</p>
+              <p>See also <xref href="intro-resize-window.dita#intro-resize-window"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_recording.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_recording.png" placement="break" align="center">
+                  <alt>Recording settings icon on the virtual machine status bar. Recording is disabled.</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_recording.png" placement="break" align="center">
+                  <alt>Recording settings icon on the virtual machine status bar. Recording is disabled.</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Recording</b></p>
+              <p>Settings for video and audio recording.</p>
+              <p>Right-click to show options to enable and disable recording, or to change recording
+                settings.</p>
+              <p>To enable recording, right-click on the status bar and select the <b>Recording</b>
+                option. The icon changes to show a movie reel animation, as follows:</p>
+             <p>
+               <xref href="images/icon_recording_enabled.png" format="png" platform="htmlhelp"> 
+                 <image href="images/icon_recording_enabled.png" placement="break" align="center">
+                 <alt>Recording settings icon on the virtual machine status bar. Recording is enabled.</alt>
+               </image>
+               </xref>
+               <image platform="ohc" href="images/icon_recording_enabled.png" align="center" placement="break">
+                 <alt>Recording settings icon on the virtual machine status bar. Recording is enabled.</alt>
+               </image>
+             </p>
+              <p>To disable recording, right-click on the status bar and deselect the
+                  <b>Recording</b> option. The icon changes back to the default image.</p>
+              <p>See also <xref href="settings-capture.dita#settings-capture"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_cpu_activity.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_cpu_activity.png" placement="break" align="center">
+                  <alt>Processor settings icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_cpu_activity.png" placement="break" align="center">
+                  <alt>Processor settings icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Processor</b></p>
+              <p>Settings for the CPU used by the virtual machine.</p>
+              <p>The colored bar in the icon indicates current processor activity. Red indicates
+                high CPU usage, Green indicates low CPU usage.</p>
+              <p>A green turtle icon indicates that a native hypervisor, such as Hyper-V, is running on the host.</p>
+              <p>
+                <xref href="images/icon_turtle.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_turtle.png" placement="break" align="center">
+                    <alt>Turtle icon on the virtual machine status bar</alt>
+                  </image>
+                </xref>
+                <image platform="ohc" href="images/icon_turtle.png" align="center" placement="break">
+                  <alt>Turtle icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+              
+              <p>See also <xref href="settings-processor.dita#settings-processor"/>.</p>
+            </entry>
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_mouse_integration.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_mouse_integration.png" placement="break" align="center">
+                    <alt>Mouse integration icon on the virtual machine status bar</alt>
+                  </image>
+                </xref>
+                <image platform="ohc" href="images/icon_mouse_integration.png" placement="break" align="center">
+                  <alt>Mouse integration icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Mouse Integration</b></p>
+              <p>Settings for capturing the host mouse pointer.</p>
+              <p>Right-click to enable or disable mouse integration.</p>
+              <p>See also <xref href="keyb_mouse_normal.dita#keyb_mouse_normal"/>.</p>
+            </entry>        
+          </row>
+          <row>
+            <entry>
+              <p>
+                <xref href="images/icon_host_key.png" format="png" platform="htmlhelp"> 
+                  <image href="images/icon_host_key.png" placement="break" align="center">
+                  <alt>Host key icon on the virtual machine status bar</alt>
+                </image>
+                </xref>
+                <image platform="ohc" href="images/icon_host_key.png" placement="break" align="center">
+                  <alt>Host key icon on the virtual machine status bar</alt>
+                </image>
+              </p>
+            </entry>
+            <entry>
+              <p><b>Host Key</b></p>
+              <p>Settings for capturing the host keyboard.</p>
+              <p>The current host key setting is displayed to the right of the icon.</p>
+              <p>Right-click to show options for configuring the host key combination and other
+                keyboard shortcuts.</p>
+              <p>Right-click to insert a special key combination, such as Ctrl-Alt-Del.</p>
+              <p>See also <xref href="specialcharacters.dita#specialcharacters"/>.</p>
+            </entry>
+          </row>
+        </tbody>
+      </tgroup>
+    </table>
+    <section id="vm-status-bar-configure">
+      <title>Configuring the Status Bar</title>
+      <p>You can configure the status bar as follows:</p>
+      <ul>
+        <li>
+          <p>To <b>hide</b> the status bar, right-click in the status bar area and deselect <b>Show Status Bar</b>.</p>
+        </li>
+        <li>
+          <p>To <b>show</b> the status bar, select <b>View</b>, <b>Status Bar</b>, <b>Show Status Bar</b> from the 
+            virtual machine's menu bar.</p>
+        </li>
+        <li>
+          <p>To <b>modify</b> the status bar contents, right-click in the status bar area and select 
+            <b>Status Bar Settings</b>. You can then do the following:</p>
+          <ul>
+            <li><p>Select icons that you want to include in the status bar.</p></li>
+            <li><p>Deselect icons that you want to remove from the status bar.</p></li>
+            <li><p>Drag and drop icons to change their order in the status bar.</p></li>
+          </ul>
+          <p>Click the check mark button to save your changes to the status bar.</p>
+          <p>See also <xref href="user-interface.dita#user-interface"/> for other options to change the status bar.</p>
+        </li>     
+      </ul>  
+      
+    </section>
+    
+   
+
+  </body>
+  
+</topic>