Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.cpp	(revision 105240)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.cpp	(revision 105241)
@@ -577,5 +577,5 @@
     {
         /* Add controller information: */
-        const QString strControllerName = QApplication::translate("UIMachineSettingsStorage", "Controller: %1");
+        const QString strControllerName = QApplication::translate("UIStorageSettingsEditor", "Controller: %1");
         table << UITextTableLine(strControllerName.arg(comController.GetName()), QString());
         /* Populate map (its sorted!): */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumTools.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumTools.cpp	(revision 105240)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumTools.cpp	(revision 105241)
@@ -247,6 +247,6 @@
         {
             filters = HDDBackends(gpGlobalSession->virtualBox());
-            strTitle = QApplication::translate("UICommon", "Please choose a virtual hard disk file");
-            allType = QApplication::translate("UICommon", "All virtual hard disk files (%1)");
+            strTitle = QApplication::translate("UIMediumTools", "Please choose a virtual hard disk file");
+            allType = QApplication::translate("UIMediumTools", "All virtual hard disk files (%1)");
             break;
         }
@@ -254,6 +254,6 @@
         {
             filters = DVDBackends(gpGlobalSession->virtualBox());
-            strTitle = QApplication::translate("UICommon", "Please choose a virtual optical disk file");
-            allType = QApplication::translate("UICommon", "All virtual optical disk files (%1)");
+            strTitle = QApplication::translate("UIMediumTools", "Please choose a virtual optical disk file");
+            allType = QApplication::translate("UIMediumTools", "All virtual optical disk files (%1)");
             break;
         }
@@ -261,6 +261,6 @@
         {
             filters = FloppyBackends(gpGlobalSession->virtualBox());
-            strTitle = QApplication::translate("UICommon", "Please choose a virtual floppy disk file");
-            allType = QApplication::translate("UICommon", "All virtual floppy disk files (%1)");
+            strTitle = QApplication::translate("UIMediumTools", "Please choose a virtual floppy disk file");
+            allType = QApplication::translate("UIMediumTools", "All virtual floppy disk files (%1)");
             break;
         }
@@ -283,5 +283,5 @@
     if (!prefixes.isEmpty())
         backends.insert(0, allType.arg(prefixes.join(" ").trimmed()));
-    backends << QApplication::translate("UICommon", "All files (*)");
+    backends << QApplication::translate("UIMediumTools", "All files (*)");
     strFilter = backends.join(";;").trimmed();
 
@@ -360,6 +360,5 @@
     pActionOpenExistingMedium->setData(QVariant::fromValue(UIMediumTarget(strControllerName, comCurrentAttachment.GetPort(),
                                                                           comCurrentAttachment.GetDevice(), enmMediumType)));
-    pActionOpenExistingMedium->setText(QApplication::translate("UIMachineSettingsStorage", "Choose/Create a disk image..."));
-
+    pActionOpenExistingMedium->setText(QApplication::translate("UIMediumTools", "Choose/Create a disk image..."));
 
     /* Prepare open medium file action: */
@@ -369,6 +368,5 @@
                                                                     comCurrentAttachment.GetDevice(), enmMediumType,
                                                                     UIMediumTarget::UIMediumTargetType_WithFileDialog)));
-    pActionFileSelector->setText(QApplication::translate("UIMachineSettingsStorage", "Choose a disk file..."));
-
+    pActionFileSelector->setText(QApplication::translate("UIStorageSettingsEditor", "Choose a disk file..."));
 
     /* Insert separator: */
@@ -483,5 +481,5 @@
         pActionUnmountMedium->setData(QVariant::fromValue(UIMediumTarget(strControllerName, comCurrentAttachment.GetPort(),
                                                                          comCurrentAttachment.GetDevice())));
-        pActionUnmountMedium->setText(QApplication::translate("UIMachineSettingsStorage", "Remove disk from virtual drive"));
+        pActionUnmountMedium->setText(QApplication::translate("UIStorageSettingsEditor", "Remove disk from virtual drive"));
         if (enmMediumType == UIMediumDeviceType_DVD)
             pActionUnmountMedium->setIcon(UIIconPool::iconSet(":/cd_unmount_16px.png", ":/cd_unmount_disabled_16px.png"));
Index: /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotDetailsWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotDetailsWidget.cpp	(revision 105240)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotDetailsWidget.cpp	(revision 105241)
@@ -1899,5 +1899,5 @@
     {
         /* Append controller information: */
-        aControllers << QApplication::translate("UIMachineSettingsStorage", "Controller: %1").arg(comController.GetName());
+        aControllers << QApplication::translate("UIStorageSettingsEditor", "Controller: %1").arg(comController.GetName());
 
         /* Prepare attachment information: */