Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDExpertPage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDExpertPage.cpp	(revision 105259)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDExpertPage.cpp	(revision 105260)
@@ -182,14 +182,20 @@
 bool UIWizardCloneVDExpertPage::isComplete() const
 {
-    bool fResult = true;
-
-    if (m_pFormatComboBox)
-        fResult = m_pFormatComboBox->mediumFormat().isNull();
-    if (m_pVariantWidget)
-        fResult = m_pVariantWidget->isComplete();
-    if (m_pMediumSizePathGroupBox)
-        fResult =  m_pMediumSizePathGroupBox->isComplete();
-
-    return fResult;
+    AssertReturn(m_pFormatComboBox, false);
+    AssertReturn(m_pVariantWidget, false);
+    AssertReturn(m_pMediumSizePathGroupBox, false);
+
+    if (m_pFormatComboBox->mediumFormat().isNull())
+        return false;
+
+    if (!m_pVariantWidget->isComplete())
+        return false;
+
+    if (!m_pMediumSizePathGroupBox->pathExists())
+        return false;
+    if (!m_pMediumSizePathGroupBox->filePathUnique())
+        return false;
+
+    return true;
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPathSizePage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPathSizePage.cpp	(revision 105259)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPathSizePage.cpp	(revision 105260)
@@ -100,5 +100,9 @@
 {
     AssertReturn(m_pMediumSizePathGroupBox, false);
-    return m_pMediumSizePathGroupBox->isComplete();
+    if (!m_pMediumSizePathGroupBox->pathExists())
+        return false;
+    if (!m_pMediumSizePathGroupBox->filePathUnique())
+        return false;
+    return true;
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp	(revision 105259)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp	(revision 105260)
@@ -332,6 +332,19 @@
 }
 
-bool UIMediumSizeAndPathGroupBox::isComplete() const
-{
+bool UIMediumSizeAndPathGroupBox::pathExists() const
+{
+    /* Check if the path upto file name exists: */
+    if (!QFileInfo(mediumPath()).exists())
+    {
+        m_pLocationEditor->mark(true, tr("Disk file path does not exists"), tr("Disk file path is valid"));
+        return false;
+    }
+    m_pLocationEditor->mark(false, tr("Disk file path does not exists"), tr("Disk file path is valid"));
+    return true;
+}
+
+bool UIMediumSizeAndPathGroupBox::filePathUnique() const
+{
+    /* Check if there is not such file already: */
     if (QFileInfo(mediumFilePath()).exists())
     {
@@ -340,5 +353,4 @@
     }
     m_pLocationEditor->mark(false, tr("Disk file name is not unique"), tr("Disk file name is valid"));
-
     return true;
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.h	(revision 105259)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.h	(revision 105260)
@@ -137,5 +137,6 @@
     void setMediumSize(qulonglong uSize);
 
-    bool isComplete() const;
+    bool filePathUnique() const;
+    bool pathExists() const;
 
 private slots:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDExpertPage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDExpertPage.cpp	(revision 105259)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDExpertPage.cpp	(revision 105260)
@@ -196,4 +196,6 @@
     if (pWizard->mediumSize() > m_uMediumSizeMax || pWizard->mediumSize() < m_uMediumSizeMin)
         return false;
+    if (!m_pSizeAndPathGroup->filePathUnique() || !m_pSizeAndPathGroup->pathExists())
+        return false;
     return true;
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMExpertPage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMExpertPage.cpp	(revision 105259)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMExpertPage.cpp	(revision 105260)
@@ -646,4 +646,8 @@
             fIsComplete = false;
         }
+        /* Check only the uniqueness of the file and not path existence since the vm folder (default medium path)
+         * has not been created yet: */
+        if (!m_pSizeAndLocationGroup->filePathUnique())
+            fIsComplete = false;
     }
     return fIsComplete;