Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.cpp	(revision 105264)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.cpp	(revision 105265)
@@ -1432,5 +1432,5 @@
 
 void UIDetailsGenerator::acquireDisplayStatusInfo(CMachine &comMachine, QString &strInfo,
-                                                  bool &fAcceleration3D)
+                                                  uint &uVRAMSize, uint &cMonitorCount, bool &fAcceleration3D)
 {
     /* Get graphics adapter: */
@@ -1438,17 +1438,14 @@
 
     /* Video Memory: */
-    const ULONG uVRAMSize = comGraphics.GetVRAMSize();
-    const QString strVRAMSize = QApplication::translate("UIIndicatorDisplay", "<nobr>%1 MB</nobr>").arg(uVRAMSize);
+    uVRAMSize = comGraphics.GetVRAMSize();
+    const QString strVRAMSize = QApplication::translate("UIIndicatorDisplay", "%1 MB").arg(uVRAMSize);
     strInfo += e_strTableRow2
         .arg(QApplication::translate("UIDetails", "Video Memory", "details (display)"), strVRAMSize);
 
     /* Monitor Count: */
-    const ULONG uMonitorCount = comGraphics.GetMonitorCount();
-    if (uMonitorCount > 1)
-    {
-        const QString strMonitorCount = QString::number(uMonitorCount);
+    cMonitorCount = comGraphics.GetMonitorCount();
+    if (cMonitorCount > 1)
         strInfo += e_strTableRow2
-            .arg(QApplication::translate("UIDetails", "Screens", "details (display)"), strMonitorCount);
-    }
+            .arg(QApplication::translate("UIDetails", "Screens", "details (display)"), QString::number(cMonitorCount));
 
     /* 3D acceleration: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.h	(revision 105264)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDetailsGenerator.h	(revision 105265)
@@ -111,5 +111,5 @@
 
     SHARED_LIBRARY_STUFF void acquireDisplayStatusInfo(CMachine &comMachine, QString &strInfo,
-                                                       bool &fAcceleration3D);
+                                                       uint &uVRAMSize, uint &cMonitorCount, bool &fAcceleration3D);
 
     SHARED_LIBRARY_STUFF void acquireRecordingStatusInfo(CMachine &comMachine, QString &strInfo,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 105264)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 105265)
@@ -544,7 +544,9 @@
 
         /* Append description with more info: */
-        const QString strAdaptersStatus = m_fAdaptersPresent ? tr("Adapters present") : tr("No network adapters");
-        const QString strCablesStatus = m_fCablesDisconnected ? tr("All cables disconnected") : QString();
-        m_strDescription = QString("%1, %2, %3").arg(m_strDescription, strAdaptersStatus, strCablesStatus);
+        QStringList info;
+        info << (m_fAdaptersPresent ? tr("Adapters present") : tr("No network adapters"));
+        if (m_fCablesDisconnected)
+            info << tr("All cables disconnected");
+        m_strDescription = QString("%1, %2").arg(m_strDescription, info.join(", "));
     }
 
@@ -717,4 +719,7 @@
     UIIndicatorDisplay(UIMachine *pMachine)
         : UISessionStateStatusBarIndicator(IndicatorType_Display, pMachine)
+        , m_uVRAMSize(0)
+        , m_cMonitorCount(0)
+        , m_fAcceleration3D(false)
     {
         /* Assign state-icons: */
@@ -735,6 +740,8 @@
     {
         QString strFullData;
-        bool fAcceleration3D = false;
-        m_pMachine->acquireDisplayStatusInfo(strFullData, fAcceleration3D);
+        m_uVRAMSize = 0;
+        m_cMonitorCount = 0;
+        m_fAcceleration3D = false;
+        m_pMachine->acquireDisplayStatusInfo(strFullData, m_uVRAMSize, m_cMonitorCount, m_fAcceleration3D);
 
         /* Update tool-tip: */
@@ -745,5 +752,5 @@
         if (m_pMachine->machineState() != KMachineState_Null)
         {
-            if (!fAcceleration3D)
+            if (!m_fAcceleration3D)
                 enmState = DisplayState_Software;
             else
@@ -755,4 +762,29 @@
         sltRetranslateUI();
     }
+
+    /** Handles translation event. */
+    virtual void sltRetranslateUI() RT_OVERRIDE
+    {
+        /* Call to base-class: */
+        UISessionStateStatusBarIndicator::sltRetranslateUI();
+
+        /* Append description with more info: */
+        QStringList info;
+        info << tr("%1 MB").arg(m_uVRAMSize);
+        if (m_cMonitorCount > 1)
+            info << tr("%1 monitors connected").arg(m_cMonitorCount);
+        if (m_fAcceleration3D)
+            info << tr("3D acceleration enabled");
+        m_strDescription = QString("%1, %2").arg(m_strDescription, info.join(", "));
+    }
+
+private:
+
+    /** Holds the VRAM size. */
+    uint  m_uVRAMSize;
+    /** Holds the monitor count. */
+    uint  m_cMonitorCount;
+    /** Holds whether 3D acceleration is enabled. */
+    bool  m_fAcceleration3D;
 };
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 105264)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 105265)
@@ -937,7 +937,7 @@
 }
 
-void UIMachine::acquireDisplayStatusInfo(QString &strInfo, bool &fAcceleration3D)
-{
-    uisession()->acquireDisplayStatusInfo(strInfo, fAcceleration3D);
+void UIMachine::acquireDisplayStatusInfo(QString &strInfo, uint &uVRAMSize, uint &cMonitorCount, bool &fAcceleration3D)
+{
+    uisession()->acquireDisplayStatusInfo(strInfo, uVRAMSize, cMonitorCount, fAcceleration3D);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 105264)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 105265)
@@ -639,5 +639,5 @@
         void acquireSharedFoldersStatusInfo(QString &strInfo, uint &cFoldersCount);
         /** Acquires status info for Display indicator. */
-        void acquireDisplayStatusInfo(QString &strInfo, bool &fAcceleration3D);
+        void acquireDisplayStatusInfo(QString &strInfo, uint &uVRAMSize, uint &cMonitorCount, bool &fAcceleration3D);
         /** Acquires status info for Recording indicator. */
         void acquireRecordingStatusInfo(QString &strInfo, bool &fRecordingEnabled, bool &fMachinePaused);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 105264)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 105265)
@@ -2043,10 +2043,10 @@
 }
 
-void UISession::acquireDisplayStatusInfo(QString &strInfo, bool &fAcceleration3D)
+void UISession::acquireDisplayStatusInfo(QString &strInfo, uint &uVRAMSize, uint &cMonitorCount, bool &fAcceleration3D)
 {
     CMachine comMachine = machine();
     if (comMachine.isNull())
         return;
-    UIDetailsGenerator::acquireDisplayStatusInfo(comMachine, strInfo, fAcceleration3D);
+    UIDetailsGenerator::acquireDisplayStatusInfo(comMachine, strInfo, uVRAMSize, cMonitorCount, fAcceleration3D);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 105264)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 105265)
@@ -521,5 +521,5 @@
         void acquireSharedFoldersStatusInfo(QString &strInfo, uint &cFoldersCount);
         /** Acquires status info for Display indicator. */
-        void acquireDisplayStatusInfo(QString &strInfo, bool &fAcceleration3D);
+        void acquireDisplayStatusInfo(QString &strInfo, uint &uVRAMSize, uint &cMonitorCount, bool &fAcceleration3D);
         /** Acquires status info for Recording indicator. */
         void acquireRecordingStatusInfo(QString &strInfo, bool &fRecordingEnabled, bool &fMachinePaused);