Index: trunk/doc/manual/en_US/dita/topics/Introduction.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/Introduction.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/Introduction.dita	(revision 105293)
@@ -5,31 +5,19 @@
   
   <body>
-    <p>
-    Welcome to <ph conkeyref="vbox-conkeyref-phrases/product-name"/>.
-  </p>
-    <p>
-    <ph conkeyref="vbox-conkeyref-phrases/product-name"/> is a cross-platform virtualization application. What
-    does that mean? For one thing, it installs on your existing Intel or
-    AMD-based computers, whether they are running Windows, macOS, Linux,
-    or Oracle Solaris operating systems (OSes). Secondly, it extends the
-    capabilities of your existing computer so that it can run multiple
-    OSes, inside multiple virtual machines, at the same time. As an
-    example, you can run Windows and Linux on your Mac, run Windows
-    Server on your Linux server, run Linux on your Windows PC, and so
-    on, all alongside your existing applications. You can install and
-    run as many virtual machines as you like. The only practical limits
-    are disk space and memory.
-  </p>
-    <p>
-    <ph conkeyref="vbox-conkeyref-phrases/product-name"/> is deceptively simple yet also very powerful. It can
-    run everywhere from small embedded systems or desktop class machines
-    all the way up to datacenter deployments and even Cloud
-    environments.
-  </p>
-    <p>
-    The following screenshot shows how <ph conkeyref="vbox-conkeyref-phrases/product-name"/>, installed on an
-    Apple Mac computer, is running Windows Server 2016 in a virtual
-    machine window.
-  </p>
+    <p>Welcome to <ph conkeyref="vbox-conkeyref-phrases/product-name"/>.</p>
+    <p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> is a cross-platform virtualization
+      application. What does that mean? For one thing, it installs on your existing Intel or
+      AMD-based computers, whether they are running Windows, macOS, Linux, or Oracle Solaris
+      operating systems (OSes). Second, it extends the capabilities of your existing computer so
+      that it can run multiple OSes, inside multiple virtual machines, at the same time. As an
+      example, you can run Windows and Linux on your Mac, run Windows Server on your Linux server,
+      run Linux on your Windows PC, and so on, all alongside your existing applications. You can
+      install and run as many virtual machines as you like. The only practical limits are disk space
+      and memory.</p>
+    <p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> is deceptively simple yet also very powerful. It can run
+      everywhere from small embedded systems or desktop class machines all the way up to data center deployments and
+      even Cloud environments. </p>
+    <p>The following screenshot shows how <ph conkeyref="vbox-conkeyref-phrases/product-name"/>, installed on an Apple
+      Mac computer, is running Windows Server 2016 in a virtual machine window. </p>
     <fig id="fig-win2016-intro">
       <title>Windows Server 2016 Virtual Machine, Displayed on a macOS Host</title>
Index: trunk/doc/manual/en_US/dita/topics/cloud-vm-monitor.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/cloud-vm-monitor.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/cloud-vm-monitor.dita	(revision 105293)
@@ -20,5 +20,5 @@
     </li>
       <li>
-        <p> Use the <cmdname>VBoxManage cloud instance</cmdname> command, as follows:</p>
+        <p>Use the <cmdname>VBoxManage cloud instance</cmdname> command, as follows:</p>
         <ul><li><p><cmdname>VBoxManage cloud instance metriclist</cmdname> shows the available metrics for an
               instance.</p></li>
Index: trunk/doc/manual/en_US/dita/topics/cloud-vm.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/cloud-vm.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/cloud-vm.dita	(revision 105293)
@@ -32,5 +32,5 @@
       </li>
       <li>
-        <p><b outputclass="bold"> Use an existing <ph conkeyref="vbox-conkeyref-phrases/oci"/>
+        <p><b outputclass="bold">Use an existing <ph conkeyref="vbox-conkeyref-phrases/oci"/>
             instance.</b> See <xref href="cloud-vm-add.dita#cloud-vm-add"/>.
           </p>
Index: trunk/doc/manual/en_US/dita/topics/install-ext-pack-manager.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/install-ext-pack-manager.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/install-ext-pack-manager.dita	(revision 105293)
@@ -3,55 +3,27 @@
 <topic xml:lang="en-us" id="install-ext-pack-manager">
   <title>The Extension Pack Manager</title>
-
+  
   <body>
-    <p>
-        Extension packs can be installed and managed using the
-        <b outputclass="bold">Extension Pack Manager</b> tool in
-        <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/>.
-      </p>
-    <p>
-        The Extension Pack Manager lists the extension packs that are
-        currently installed on the host, and enables you to install and
-        uninstall extension packs.
-      </p>
-    <p>
-        To display the Extension Pack Manager, go to the global
-        <b outputclass="bold">Tools</b> menu and click
-        <b outputclass="bold">Extensions</b>. The Extension Pack
-        Manager is shown.
-      </p>
-    <p>
-        To install an extension pack using the Extension Pack Manager,
-        click <b outputclass="bold">Install</b> and select an
-        extension package file. The extension pack is installed on the
-        host and listed in Extension Pack Manager.
-      </p>
-    <p>
-        To uninstall an extension pack with the Extension Pack Manager,
-        do the following:
-      </p>
+    <p>Extension packs can be installed and managed using the <b outputclass="bold">Extension Pack Manager</b> tool in
+        <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/>. </p>
+    <p>The Extension Pack Manager lists the extension packs that are currently installed on the host, and enables you to
+      install and uninstall extension packs. </p>
+    <p>To display the Extension Pack Manager, go to the global <b outputclass="bold">Tools</b> menu and click <b
+        outputclass="bold">Extensions</b>. The Extension Pack Manager is shown. </p>
+    <p>To install an extension pack using the Extension Pack Manager, click <b outputclass="bold">Install</b> and select
+      an extension package file. The extension pack is installed on the host and listed in Extension Pack Manager. </p>
+    <p>To uninstall an extension pack with the Extension Pack Manager, do the following: </p>
     <ol>
       <li>
-        <p>
-            Select the extension pack in the Extension Pack Manager
-            window and click <b outputclass="bold">Uninstall</b>.
-          </p>
+        <p>Select the extension pack in the Extension Pack Manager window and click <b outputclass="bold">Uninstall</b>. </p>
       </li>
       <li>
-        <p>
-            Click <b outputclass="bold">Remove</b> in the prompt
-            dialog.
-          </p>
-        <p>
-            The extension pack is uninstalled from the host and removed
-            from the Extension Pack Manager.
-          </p>
+        <p>Click <b outputclass="bold">Remove</b> in the prompt dialog. </p>
+        <p>The extension pack is uninstalled from the host and removed from the Extension Pack Manager. </p>
       </li>
     </ol>
-    <p>
-        Alternatively, you can use the <userinput>VBoxManage</userinput> command line to install and
-        manage an <ph conkeyref="vbox-conkeyref-phrases/vbox-ext"/>. See <xref href="vboxmanage-extpack.dita"/>.
-    </p>
+    <p>Alternatively, you can use the <userinput>VBoxManage</userinput> command line to install and manage an <ph
+        conkeyref="vbox-conkeyref-phrases/vbox-ext"/>. See <xref href="vboxmanage-extpack.dita"/>. </p>
   </body>
-
+  
 </topic>
Index: trunk/doc/manual/en_US/dita/topics/install-ext-pack.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/install-ext-pack.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/install-ext-pack.dita	(revision 105293)
@@ -11,5 +11,5 @@
     <ol>
       <li>
-        <p> Double-click the extension package file name. </p>
+        <p>Double-click the extension package file name. </p>
         <p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> extension packs have a
             <filepath>.vbox-extpack</filepath> file name extension. </p>
Index: trunk/doc/manual/en_US/dita/topics/legacy-fullscreen-mode.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/legacy-fullscreen-mode.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/legacy-fullscreen-mode.dita	(revision 105293)
@@ -6,11 +6,9 @@
   <body>
     <p>
-        <ph conkeyref="vbox-conkeyref-phrases/product-name"/> uses special window manager facilities to switch
-        a multi-screen machine to full-screen on a multi-monitor host
-        system. However, not all window managers provide these
-        facilities correctly. <ph conkeyref="vbox-conkeyref-phrases/product-name"/> can be configured to use a
-        legacy method of switching to full-screen mode instead, by using
-        the command:
-      </p>
+      <ph conkeyref="vbox-conkeyref-phrases/product-name"/> uses special window manager facilities
+      to switch a multiscreen machine to full-screen on a multimonitor host system. However, not all
+      window managers provide these facilities correctly. <ph
+        conkeyref="vbox-conkeyref-phrases/product-name"/> can be configured to use a legacy method
+      of switching to full-screen mode instead, by using the command: </p>
     <pre xml:space="preserve">VBoxManage setextradata global GUI/Fullscreen/LegacyMode true</pre>
     <p>
Index: trunk/doc/manual/en_US/dita/topics/natforward.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/natforward.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/natforward.dita	(revision 105293)
@@ -3,5 +3,5 @@
 <topic xml:lang="en-us" id="natforward">
   <title>Configuring Port Forwarding with NAT</title>
-
+  
   <body>
     <p>
@@ -35,8 +35,6 @@
         traffic to be routed to a specific port in the guest.
       </p>
-    <p>
-        Alternatively, the command line tool <userinput>VBoxManage</userinput> can be used. See
-        <xref href="vboxmanage-modifyvm.dita"/>.
-    </p>
+    <p> Alternatively, the command line tool <userinput>VBoxManage</userinput> can be used. See
+        <xref href="vboxmanage-modifyvm.dita"/>. </p>
     <p>
         You will need to know which ports on the guest the service uses
@@ -87,9 +85,7 @@
         guest.
       </p>
-    <p>
-        It is possible to configure incoming NAT connections while the VM is running, see <xref
-        href="vboxmanage-controlvm.dita"/>.
-    </p>
+    <p> It is possible to configure incoming NAT connections while the VM is running, see <xref
+        href="vboxmanage-controlvm.dita"/>. </p>
   </body>
-
+  
 </topic>
Index: trunk/doc/manual/en_US/dita/topics/network_hostonly.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/network_hostonly.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/network_hostonly.dita	(revision 105293)
@@ -73,8 +73,7 @@
       </li>
       <li>
-        <p>
-          On the command line, use <userinput>VBoxManage modifyvm vmname --nic
-          <varname>x</varname> hostonly</userinput>. See <xref href="vboxmanage-modifyvm.dita"/>.
-        </p>
+        <p> On the command line, use <userinput>VBoxManage modifyvm vmname --nic
+              <varname>x</varname> hostonly</userinput>. See <xref href="vboxmanage-modifyvm.dita"
+          />. </p>
       </li>
     </ul>
Index: trunk/doc/manual/en_US/dita/topics/network_internal.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/network_internal.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/network_internal.dita	(revision 105293)
@@ -40,12 +40,9 @@
       </li>
     </ul>
-    <p>
-      Unless you configure the virtual network cards in the guest operating systems that are
+    <p>Unless you configure the virtual network cards in the guest operating systems that are
       participating in the internal network to use static IP addresses, you may want to use the DHCP
       server that is built into <ph conkeyref="vbox-conkeyref-phrases/product-name"/> to manage IP addresses for the internal
-      network. See <xref href="vboxmanage-dhcpserver.dita"/>.
-    </p>
-    <p>
-      As a security measure, by default, the Linux implementation of
+      network. See <xref href="vboxmanage-dhcpserver.dita"/>. </p>
+    <p>As a security measure, by default, the Linux implementation of
       internal networking only allows VMs running under the same user ID
       to establish an internal network. However, it is possible to
@@ -54,4 +51,4 @@
     </p>
   </body>
-
+  
 </topic>
Index: trunk/doc/manual/en_US/dita/topics/networkingdetails.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/networkingdetails.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/networkingdetails.dita	(revision 105293)
@@ -3,5 +3,5 @@
 <topic xml:lang="en-us" id="networkingdetails">
   <title>Virtual Networking</title>
-
+  
   <body>
     <p>
@@ -24,10 +24,8 @@
       </li>
     </ul>
-    <p>
-      Four of the network cards can be configured in the <b outputclass="bold">Network</b> section
+    <p> Four of the network cards can be configured in the <b outputclass="bold">Network</b> section
       of the <b outputclass="bold">Settings</b> window in <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/>. You can configure all
       eight network cards on the command line using <userinput>VBoxManage modifyvm</userinput>. See
-      <xref href="vboxmanage-modifyvm.dita"/>.
-    </p>
+        <xref href="vboxmanage-modifyvm.dita"/>. </p>
     <p>
     This chapter explains the various networking settings in more
Index: trunk/doc/manual/en_US/dita/topics/snapshots-take-restore-delete.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/snapshots-take-restore-delete.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/snapshots-take-restore-delete.dita	(revision 105293)
@@ -6,73 +6,40 @@
                
                <body>
-                  <p>
-        There are three operations related to snapshots, as follows:
-      </p>
+                  <p>There are three operations related to snapshots, as follows: </p>
                   <ol>
                      <li>
-                        <p>
-                           <b outputclass="bold">Take a snapshot.</b> This makes
-            a copy of the machine's current state, to which you can go
-            back at any given time later.
-          </p>
+                        <p><b outputclass="bold">Take a snapshot.</b> This makes a copy of the machine's current state,
+          to which you can go back at any given time later. </p>
                         <ul>
                            <li>
-                              <p>
-                If your VM is running:
-              </p>
-                              <p>
-                Select <b outputclass="bold">Take Snapshot</b>
-                from the <b outputclass="bold">Machine</b> menu
-                in the VM window.
-              </p>
-                              <p>
-                The VM is paused while the snapshot is being created.
-                After snapshot creation, the VM continues to run as
-                normal.
-              </p>
+                              <p>If your VM is running: </p>
+                              <p>Select <b outputclass="bold">Take Snapshot</b> from the <b outputclass="bold"
+                >Machine</b> menu in the VM window. </p>
+                              <p>The VM is paused while the snapshot is being created. After snapshot creation, the VM
+              continues to run as normal. </p>
                            </li>
                            <li>
-                              <p>
-                If your VM is in either the Saved or the Powered Off
-                state, as displayed next to the VM name in the machine
-                list:
-              </p>
-                              <p>
-                Display the Snapshots window and do one of the
-                following:
-              </p>
+                              <p>If your VM is in either the Saved or the Powered Off state, as displayed next to the VM
+              name in the machine list: </p>
+                              <p>Display the Snapshots window and do one of the following: </p>
                               <ul>
                                  <li>
-                                    <p>
-                    Click <b outputclass="bold">Take</b> in the
-                    Snapshots window toolbar.
-                  </p>
+                                    <p>Click <b outputclass="bold">Take</b> in the Snapshots window toolbar. </p>
                                  </li>
                                  <li>
-                                    <p> Right-click the <b outputclass="bold">Current State</b> item
-                  in the list and select <b outputclass="bold">Take</b>. </p>
+                                    <p>Right-click the <b outputclass="bold">Current State</b> item in the list and
+                  select <b outputclass="bold">Take</b>. </p>
                                  </li>
                               </ul>
                            </li>
                         </ul>
-                        <p>
-            A dialog is displayed, prompting you for a snapshot name.
-            This name is purely for reference purposes, to help you
-            remember the state of the snapshot. For example, a useful
-            name would be "Fresh installation from scratch, no Guest
-            Additions", or "Service Pack 3 just installed". You can also
-            add a longer text description in the
-            <b outputclass="bold">Snapshot Description</b> field.
-          </p>
-                        <p>
-            Your new snapshot will then appear in the snapshots list.
-            Underneath your new snapshot, you will see an item called
-            <b outputclass="bold">Current State</b>, signifying
-            that the current state of your VM is a variation based on
-            the snapshot you took earlier. If you later take another
-            snapshot, you will see that they are displayed in sequence,
-            and that each subsequent snapshot is derived from an earlier
-            one.
-          </p>
+                        <p>A dialog is displayed, prompting you for a snapshot name. This name is purely for reference
+          purposes, to help you remember the state of the snapshot. For example, a useful name would be <i>Fresh
+            installation from scratch, no Guest Additions</i>, or <i>Service Pack 3 just installed</i>. You can also add
+          a longer text description in the <b outputclass="bold">Snapshot Description</b> field. </p>
+                        <p>Your new snapshot will then appear in the snapshots list. Underneath your new snapshot, you
+          will see an item called <b outputclass="bold">Current State</b>, signifying that the current state of your VM
+          is a variation based on the snapshot you took earlier. If you later take another snapshot, you will see that
+          they are displayed in sequence, and that each subsequent snapshot is derived from an earlier one. </p>
                        <fig id="fig-snapshots-list">
                          <title>Snapshots List For a Virtual Machine</title>
Index: trunk/doc/manual/en_US/dita/topics/snapshots.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/snapshots.dita	(revision 105289)
+++ trunk/doc/manual/en_US/dita/topics/snapshots.dita	(revision 105293)
@@ -10,5 +10,5 @@
       virtual machine is thus similar to a machine in Saved state, but there can be many of them, and these saved states
       are preserved. </p>
-               <p> To see the snapshots of a virtual machine, click the machine name in <ph
+               <p>To see the snapshots of a virtual machine, click the machine name in <ph
         conkeyref="vbox-conkeyref-phrases/vbox-mgr"/>. In the machine tools menu for the VM, click <b outputclass="bold"
         >Snapshots</b>. The Snapshots tool is displayed. </p>